<template>
    <div class="card shadow mb-4">
        <div
            class="card-header bg-white py-3 d-flex flex-row align-items-center justify-content-between"
        >
            <h6 class="m-0 font-weight-bold text-primary text-capitalize">
                <router-link
                    :event="disabled ? '' : 'click'"
                    :to="{ name: 'ItemShow', params: { id: this.id } }"
                    >{{ dataObject.name }}</router-link
                >
            </h6>
            <div
                class="dropdown no-arrow"
                v-show="!disabled || editable || deletable"
            >
                <a
                    class="dropdown-toggle"
                    href="#"
                    role="button"
                    id="dropdownMenuLink"
                    data-toggle="dropdown"
                    aria-haspopup="true"
                    aria-expanded="false"
                >
                    <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
                </a>
                <div
                    class="dropdown-menu dropdown-menu-right shadow animated--fade-in"
                    aria-labelledby="dropdownMenuLink"
                >
                    <router-link
                        class="dropdown-item text-warning"
                        v-show="!disabled || editable"
                        :to="{
                            name: 'ItemEdit',
                            params: { id: this.id }
                        }"
                        >Edit</router-link
                    >
                    <a
                        class="dropdown-item text-danger"
                        v-show="!disabled || deletable"
                        @click="onDelete"
                        >Delete</a
                    >
                </div>
            </div>
        </div>
        <div class="card-body px-5">
            <div class="row align-items-center text-right">
                <div class="col-12 col-md-2 text-center">
                    <a :href="this.defaultImage" data-fancybox>
                        <img
                            :src="this.defaultImage"
                            class="img-thumbnail"
                            width="100"
                            alt="Item Image"
                        />
                    </a>
                </div>
                <div class="col-12 col-md-10">
                    <div class="row">
                        <div class="col-12 col-md-6" :class="borderRight">
                            <div class="text-xs text-uppercase mb-1">
                                Description
                            </div>
                            <div class="h5 mb-0 text-gray-800 text-capitalize">
                                {{
                                    dataObject.description
                                        ? dataObject.description
                                        : "NA"
                                }}
                            </div>
                        </div>
                        <div class="col-12 col-md-3" :class="borderRight">
                            <div class="text-xs text-uppercase mb-1">
                                Price Rate
                            </div>
                            <div class="h5 mb-0 text-gray-800 text-capitalize">
                                {{ dataObject.price_rate | currency }}
                            </div>
                        </div>
                        <div class="col-12 col-md-3" :class="borderRight">
                            <div class="text-xs text-uppercase mb-1">
                                Amount
                            </div>
                            <div class="h5 mb-0 text-gray-800 text-capitalize">
                                {{ dataObject.amount | number }}
                            </div>
                        </div>
                        <div
                            class="col-12 col-md-3"
                            v-for="(meta, index) in dataObject.metas"
                            :key="index"
                            :class="borderRight"
                        >
                            <div class="text-xs text-uppercase mb-1">
                                {{ meta.key }}
                            </div>
                            <div class="h5 mb-0 text-gray-800 text-capitalize">
                                {{ meta.value }}
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="card-footer text-center">
            <div class="collapse" :id="'collapseTarget' + _uid">
                <item-card
                    v-for="item in this.dataObject.items"
                    :key="item.id"
                    :object="item"
                    :disabled="true"
                    :deletable="true"
                    :editable="true"
                    @delete="onDeleted"
                >
                </item-card>
            </div>
            <a
                data-toggle="collapse"
                :data-target="'#collapseTarget' + _uid"
                class="text-dark"
            >
                <div>
                    <i class="fa fa-bars" aria-hidden="true"></i>
                </div>
            </a>
        </div>
    </div>
</template>

<script>
import Swal from "sweetalert2";
export default {
    components: {
        ItemCard: () => import("./ItemCardComponent")
    },
    props: ["object", "disabled", "deletable", "editable"],
    data() {
        return {
            dataObject: {},
            id: 0,
            borderRight: { "border-right": window.innerWidth > 767 }
        };
    },
    created() {
        this.prepare();
    },
    methods: {
        prepare() {
            if (this.object) {
                this.dataObject = this.object;
                this.id = this.object.id;
            } else if (this.$route.params.id) {
                this.getObject(this.$route.params.id);
                this.id = this.$route.params.id;
            }
        },
        getObject(id) {
            axios
                .get("/api/item/get/" + id)
                .then(res => {
                    this.dataObject = res.data;
                })
                .catch(err => {
                    console.warn(err.message);
                });
        },
        onDelete() {
            Swal.fire({
                title: "Are you sure?",
                text: "You won't be able to revert this!",
                icon: "warning",
                showCancelButton: true,
                confirmButtonColor: "#3085d6",
                cancelButtonColor: "#d33",
                confirmButtonText: "Yes, delete it!"
            }).then(result => {
                if (result.isConfirmed) {
                    axios
                        .delete("/item/" + this.dataObject.id)
                        .then(res => {
                            Swal.fire("Deleted!", "", "success").then(
                                result => {
                                    this.$emit("delete");

                                    if (this.$route.name == "ItemShow") {
                                        this.$router.push({
                                            name: "ItemIndex"
                                        });
                                    }
                                }
                            );
                        })
                        .catch(err => {
                            console.warn(err);
                            Swal.fire("Error!", err.message, "error");
                        });
                }
            });
        },
        onDeleted() {
            this.$emit("delete");
        }
    },
    computed: {
        defaultImage() {
            return this.dataObject.image_path
                ? "/storage/items/" + this.dataObject.image_path
                : "/img/no_image.jpg";
        }
    }
};
</script>
